=== src/chat/CMakeLists.txt ===
wl_library(chat
  SRCS
    chat.h
    chat.cc
  DEPENDS
    notifications
)
