=== debian/changelog ===
widelands (1:19+repack-4ubuntu0.18.04.1) bionic; urgency=medium

  * Use hicolor theme icon for .desktop. This allows Widelands to
    show in the Ubuntu Software app. (LP: #1789023)

 -- Jeremy Bicha <jbicha@ubuntu.com>  Mon, 03 Sep 2018 20:23:00 -0400

widelands (1:19+repack-4build4) bionic; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Nov 2017 13:56:11 +0000

widelands (1:19+repack-4build3) bionic; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Nov 2017 08:31:14 +0000

widelands (1:19+repack-4build2) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 19:49:24 +0000

widelands (1:19+repack-4build1) bionic; urgency=medium

  * No-change rebuild for libicu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 25 Oct 2017 15:28:39 +0000
